//
//  Moore.h
//  cocoaModem 2.0
//
//  Created by Kok Chen on 2/6/06.


//	see http://www.wunclub.com/digfaq/signals.html
//  and http://ftp.funet.fi/pub/dx/text/utility/Moore.code

#ifndef _MOORE_H_
	#define	_MOORE_H_
	#include <Carbon/Carbon.h>
	
	//  there are two Moore codes in use -- ITA3 and the CCIR476 that is used by SITOR-B and AMTOR.

	#define CCIR476
	
	#ifdef ITA3

		static char mooreLtrs[] = {  	
				/*        0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  */
				/* 0x */ '~', '~', '~', '~', '~', '~', '~', 'I', '~', '~', '~', ' ', '~', '\n', 'E', '~',
				/* 1x */ '~', '~', '~', 'R', '~', 'N', '~', '~', '~', 'C', '~', '~', 'D', '~', '~', '~',
				/* 2x */ '~', '~', '~', 'L', '~', 'H', 'U', '~', '~', 'P', 'S', '~', 'A', '~', '~', '~',
				/* 3x */ '~', 'O', '~', '~', 'X', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~',
				/* 4x */ '~', '~', '~', 'G', '~', 'M', 'Z', '~', '~', 'V', '~', '~', 'B', '~', '~', '~',
				/* 5x */ '~', 'T', 'W', '~', 'Y', '~', '~', '~', 'Q', '~', '~', '~', '~', '~', '~', '~',
				/* 6x */ '~', '\r', 'J', '~', 'F', '~', '~', '~', 'K', '~', '~', '~', '~', '~', '~', '~',
				/* 7x */ '*', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~',
		} ;

		static char mooreFigs[] = {  
				/*        0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  */
				/* 0x */ '~', '~', '~', '~', '~', '~', '~', '8', '~', '~', '~', ' ', '~', '\n', '3', '~',
				/* 1x */ '~', '~', '~', '4', '~', ',', '~', '~', '~', ':', '~', '~', '$', '~', '~', '~',
				/* 2x */ '~', '~', '~', ')', '~', '#', '7', '~', '~', '0', '\'', '~', '-', '~', '~', '~',
				/* 3x */ '~', '9', '~', '~', '/', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~',
				/* 4x */ '~', '~', '~', '&', '~', '.', '+', '~', '~', '=', '~', '~', '?', '~', '~', '~',
				/* 5x */ '~', '5', '2', '~', '6', '~', '~', '~', '1', '~', '~', '~', '~', '~', '~', '~',
				/* 6x */ '~', '\r', '*', '~', '!', '~', '~', '~', '(', '~', '~', '~', '~', '~', '~', '~',
				/* 7x */ '*', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~',
		} ;
	
		/*
			0x07	I		8
			0x0b	SP		SP
			0x0d	LF		LF
			0x0e	E		3
			0x13	R		4
			0x15	N		,
			0x16	-  RQ   -
			0x19	C		:
			0x1a	- beta  -
			0x1c	D		WRU
			0x23	L		)
			0x25	H		#
			0x26	U		7
			0x29	P		0
			0c2a	S		'
			0x2c	A		-
			0x31	O		9
			0x32	FIGS	FIGS
			0x34	X		/
			0x38	LTRS	LTRS
			0x43	G		&
			0x45	M		.
			0x46	Z		+
			0x49	V		=
			0x4a	- alpha -
			0x4c	B		?
			0x51	T		5
			0x52	W		2
			0x54	Y		6
			0x58	Q		1
			0x61	CR		CR
			0x62	J		BELL
			0x64	F		!
			0x68	K		(
			0x70	NULL	NULL
		*/
		
		#define MOOREFIGSCODE	0x32
		#define MOORELTRSCODE	0x38
		#define MOORENULL		0x70

		#define	RQ			0x16
		#define	beta		0x4a		// idle
		#define	alpha		0x1a		// idle
		
	#endif /* ITA3 */
	
	#ifdef CCIR476

		static char mooreLtrs[] = {  	
				/*        0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  */
				/* 0x */ '~', '~', '~', '~', '~', '~', '~', '\r', '~', '~', '~', 'T', '~', 'B', 'O', '~',
				/* 1x */ '~', '~', '~', '\n', '~', 'N', 'H', '~', '~', '*', 'L', '~', 'Z', '~', '~', '~',
				/* 2x */ '~', '~', '~', ' ', '~', '*', 'N', '~', '~', 'E', 'R', '~', 'D', '~', '~', '~',
				/* 3x */ '~', 'U', 'I', '~', 'S', '~', '~', '~', 'A', '~', '~', '~', '~', '~', '~', '~',
				/* 4x */ '~', '~', '~', 'V', '~', 'X', 'M', '~', '~', '*', 'G', '~', 'B', '~', '~', '~',
				/* 5x */ '~', 'Q', 'P', '~', 'Y', '~', '~', '~', 'W', '~', '~', '~', '~', '~', '~', '~',
				/* 6x */ '~', 'K', 'C', '~', 'F', '~', '~', '~', 'J', '~', '~', '~', '~', '~', '~', '~',
				/* 7x */ '*', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~',
		} ;

		static char mooreFigs[] = {  
				/*        0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  */
				/* 0x */ '~', '~', '~', '~', '~', '~', '~', '\r', '~', '~', '~', '5', '~', '?', '9', '~',
				/* 1x */ '~', '~', '~', '\n', '~', ',', '#', '~', '~', '*', ')', '~', '+', '~', '~', '~',
				/* 2x */ '~', '~', '~', ' ', '~', '*', ',', '~', '~', '3', '4', '~', '$', '~', '~', '~',
				/* 3x */ '~', '7', '8', '~', '*', '~', '~', '~', '-', '~', '~', '~', '~', '~', '~', '~',
				/* 4x */ '~', '~', '~', '=', '~', '/', '.', '~', '~', '*', '&', '~', '?', '~', '~', '~',
				/* 5x */ '~', '1', '0', '~', '6', '~', '~', '~', '2', '~', '~', '~', '~', '~', '~', '~',
				/* 6x */ '~', '(', ':', '~', '!', '~', '~', '~', '\'', '~', '~', '~', '~', '~', '~', '~',
				/* 7x */ '*', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~', '~',
		} ;
	
		/*
			0x07	cr		cr
			0x0b	T		5
			0x0d	B		?
			0x0e	O		9
			0x13	lf		lf
			0x15	NULL	NULL
			0x16	H		#
			0x19	RQ		RQ
			0x1a	L		)
			0x1c	Z		+
			0x23	sp		sp
			0x25	FIGS	FIGS
			0x26	N		,
			0x29	E		3
			0c2a	R		4
			0x2c	D		$
			0x31	U		7
			0x32	I		8
			0x34	S		bell
			0x38	A		-
			0x43	V		=
			0x45	X		/
			0x46	M		.
			0x49	LTRS	LTRS
			0x4a	G		&
			0x4c	beta	beta
			0x51	Q		1
			0x52	P		0
			0x54	Y		6
			0x58	W		2
			0x61	K		(
			0x62	C		:
			0x64	F		!
			0x68	J		'
			0x70	alpha	alpha
		*/
		
		#define MOOREFIGSCODE	0x49
		#define MOORELTRSCODE	0x25
		#define MOORENULL		0x15

		#define	RQ			0x19
		#define	alpha		0x70		// idle
		#define	beta		0x4c		// idle
		
	#endif /* CCIR476 */
	
#endif

